<!DOCTYPE html>
<html lang=" en">
<head>
    <title>64.30</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"></link>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container">
        <h2 style="text-align : center; ">Quản trị Drink</h2>
        <div class="jumbotron container">
            <div class="row form-group">
                <div class="col-sm-3">
                    <label >Mã Nước Uống</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-drink-code" placeholder= "Drink code" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label >Tên Nước Uống</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-drink-name" placeholder= "Name code" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label >Đơn giá</label>
                </div>
                <div class="col-sm-9">
                    <input type="number" id="input-price" placeholder= "Price" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label>Ghi chú</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-note" placeholder= "Note" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label>Ngày tạo</label>
                </div>
                <div class="col-sm-9">
                    <input type="date" id="input-createDate" placeholder= "Create Date" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label>Ngày sửa</label>
                </div>
                <div class="col-sm-9">
                    <input type="date" id="input-updateDate" placeholder= "Update Date" class="form-control">
                </div>
            </div>

            <div class="col-sm-12">
                <div class="row">
                    <div class="col-sm-8">
                        <div class="row pull-right">
                            <div class="col-sm-12">
                                <button id="save-data" class="btn btn-info">Save Data</button>
                            </div>
                        </div>
                    </div>

                    <div class="col-sm-4">
                        <div class="row ml-5 pl-5" >
                            <div class="col-sm-12">
                                <button id="create-data" class="btn btn-info">Create Data</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
         
           
        </div>
        <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Mã nước uống</th>
                    <th>Tên nước uống</th>
                    <th>Đơn giá</th>
                    <th>Ghi chú</th>
                    <th>Ngày tạo</th>
                    <th>Ngày cập nhật</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    $(document).ready(function(){
        var gId = "";
        var gFORM_MODE_INSERT = "Insert";
        var gFORM_MODE_UPDATE = "Update";
        var gFormMode = gFORM_MODE_INSERT;

        
        var table = $("#user-table").DataTable({
            "columns": [
                {"data": "id"},
                {"data": "maNuocUong"},
                {"data": "tenNuocUong"},
                {"data": "donGia"},
                {"data": "ghiChu"},
                {"data": "ngayTao"},
                {"data": "ngayCapNhat"},
                {"data": "Action"},
            ],
            "columnDefs" : [
                {
                    targets: 7,
                    defaultContent: "<button class='btn btn-primary'>Chi tiết</button>" 
                },                
            ]
        });
        $.ajax({
            url: "http://localhost:8080/drinks",
            type: "GET",
            dataType : "json",
            success: function(res){
                console.log(res) ;
                table.clear();
                table.rows.add(res);
                table.draw();
            },
            error: function(err){
                console.log(err.response);
            }
        });
        $(document).on("click", "tr", function(){
            onBtnDetailClick(this) ;
        });
        $(document).on("click", "#delete-data", function (){
            onBtnDeleteClick();
        });
        $(document).on("click", "#delete-all-data", function (){
            onBtnAllDeleteClick();
        });
        $(document).on("click", "#save_data", function (){
            onBtnSaveDataClick();
        });
        $(document).on("click", "#create-data" , function (){
            onBtnCreateClick();
        });

        


        function onBtnDetailClick(paramElement){
            gFormMode = gFORM_MODE_UPDATE;
            var vRowSelected = $(paramElement).closest("tr");
            var vTable = $("#user-table").DataTable();
            var vDataRow = vTable.row(vRowSelected).data() ;
            gId = vDataRow.id;
            $.ajax({
                url: "http://localhost:8080/drink-info?id=" + gId,
                type: "GET",
                dataType : "json",
                success: function(res){
                    console.log(res);
                    $("#input-drink-code").val(res.maNuocUong);
                    $("#input-drink-name").val(res.tenNuocUong) ;
                    $("#input-price").val(res.donGia);
                    $("#input-note").val(res.ghiChu);
                    let vCreateDate = res.ngayTao.slice(6, 10) + "-" + res.ngayTao.slice(3,5) + "-" + res.ngayTao.slice(0, 2);
                    $("#input-createDate").val(vCreateDate);
                    if(res.ngayCapNhat !== null){
                        let vUpdateDate = res.ngayCapNhat.slice(6, 10) + "-" + res.ngayCapNhat.slice(3,5) + "-" + res.ngayCapNhat.slice(0, 2);
                        $("#input-updateDate").val(vUpdateDate);
                    }
                    else {
                        $("#input-updateDate").val(null);
                    }
                    $(".pull-right"). html(`
                        <div class="col-sm-4">
                            <button id="save_data" class="btn btn-info">Save Data</button>
                        </div>
                        <div class="col-sm-4">
                            <button id="delete-data" class="btn btn-danger ml-3">Delete ID</button>
                        </div>
                        <div class="col-sm-4">
                            <button id="delete-all-data" class="btn btn-danger ml-3" >Delete All Data</button>
                        </div>`
                    )
                },
                error: function(err){
                    console.log(err.response);
                }
            });
        }
        function onBtnCreateClick(){
            let vObjectRequest = {
                        maNuocUong: $("#input-drink-code").val(),
                        tenNuocUong: $("#input-drink-name").val(),
                        donGia: $("#input-price").val(),
                        ghiChu: $("#input-note").val(),
                };
                $.ajax({
                    url:"http://localhost:8080/drink-create",
                    contentType: "application/json; charset=UTF-8",
                    type: "POST",
                    dataType: "json",
                    data: JSON.stringify (vObjectRequest),
                    success: function (res){
                        window.location.reload();
                    },
                    error: function(err){
                        console.log(err.response);
                    
                    }
                })
        }
        function onBtnSaveDataClick(){
            if(gFormMode === gFORM_MODE_UPDATE){
                let vObjectRequest = {
                    id: gId,
                    maNuocUong: $("#input-drink-code").val(),
                    tenNuoctong: $("#input- drink-name").val(),
                    donGia: $("#input-price").val(),
                    ghiChu: $("#input-note").val(),
                };
                $.ajax({
                    url:"http://localhost:8080/drink-update?id=" + gId,
                    contentType: "application/json; charset=UTF-8",
                    type: "PUT",
                    dataType: "json",
                    data: JSON.stringify(vObjectRequest),
                    success: function(res){
                        window.location.reload();
                    },
                    error: function(err){
                        console.log(err.response);
                    }
                });
            }
        }

        function onBtnDeleteClick(){
            if(confirm( "Ban có muõn xóa?") == true){
                $.ajax({
                    url: "http://localhost:8088/drink-delete/" + gId,
                    type: "DELETE",
                    dataType : "json",
                    success: function(res){
                        window.location.reload();
                    },
                    error: function(err){
                        console.log(err.response);
                    }
                });
            };
        }


        function onBtnAllDeleteClick(){
            if(confirm( "Bạn có muốn xóa toàn bộ danh sách drink?") == true) {
                $.ajax({
                    url: "http://localhost:8088/drink-delete-all",
                    type: "DELETE",
                    dataType : "json",
                    success: function(res){
                        window.location.reload();
                    },
                    error: function(err){
                        console.log(err.response);
                    }
                });
            };
        }
                                
    });
</script>
</html>